<template>
  <div class="container">
    <div class="google-map" id="map"></div>
    
    <form class="form">
      <div class="col">
        <div class="col">
          <label for="country">Country</label>
          <input
            type="text"
            class="form-control"
            id="country"
            placeholder="City"
          >
        </div>

        <div class="col">
          <label for="city">City</label>
          <input
            type="text"
            class="form-control"
            id="city"
            placeholder="City"
          >
        </div>

        <div class="col">
          <label for="lat">Latitude</label>
          <input
            type="text"
            class="form-control"
            id="lat"
            placeholder="Latitude"
          >
        </div>
      
        <div class="col">
          <label for="lng">Longitude</label>
          <input
            type="text"
            class="form-control"
            id="lng"
            placeholder="Longitude"
          >
        </div>
      </div>
    </form>
    
  </div>
</template>

<script>
export default {
  name: "google-map",
  props: ["name"],
  data() {
    return {
      token: null,
      map: null,
      locations: [],
      markers: [],
      country: null,
      city: null,
      lat: 0.0,
      lng: 0.0,
      currentPosition: null,
      currentPosMarker: null
    };
  },
  created: function() {},
  mounted: async function() {
    await fetch("http://127.0.0.1:3000/auth", {
      mode: "cors"
    })
      .then(response => {
        return response.json();
      })
      .then(data => {
        //console.log(data.data);
        this.token = data.data;
      })
      .catch(error => {
        console.error(error);
      });
    // console.log(this.token);
    await this.initMap();
    await this.getAllMarkers();
    await this.getGeocodePosition();
    await this.getCurrentPosition();
    //await this.getCoordsFromMarkers();
    //this.createCustomMarker(40.57654, -3.92658);
  },
  methods: {
    initMap: async function() {
      this.map = await new google.maps.Map(document.querySelector("#map"), {
        center: { lat: 40.416775, lng: -3.70379 },
        zoom: 6
      });
      // this.map.addListener('click', function(e){
      //   console.log(e.pa);
      // });
    },
    getAllMarkers: async function() {
      await fetch(`http://127.0.0.1:3000/locations?authorization=${this.token}`, {
        mode: "cors"
      })
      .then(response => response.json())
      .then(data => {
        this.locations = data;
        this.locations.forEach(element => {
          this.markers.push(element);
          let marker = {
            lat: element.location.coordinates[0],
            lng: element.location.coordinates[1]
          };
          let mapMarker = new google.maps.Marker({
            position: marker,
            map: this.map,
            draggable: true,
            clickable: true
          });
          this.locations.push(mapMarker);
          // google.maps.event.addListener(mapMarker, "click", function(event) {
          //   //console.log(this.position.lat(), this.position.lng());
          //   this.lat = this.position.lat();
          //   this.lng = this.position.lng();          
          //   document.querySelector('#lat').value = this.lat;
          //   document.querySelector('#lng').value = this.lng;
          //   await fetch('https://maps.googleapis.com/maps/api/geocode/json?')
          // });
          //this.markers.push(mapMarker);
        });
      })
      .catch(e => console.error(e));
    },
    createCustomMarker: function(lat, lng) {
      let marker = { lat: lat, lng: lng };
      let mapMarker = new google.maps.Marker({
        position: marker,
        map: this.map
      });
    },
    getGeocodePosition: async function() {
      this.locations.forEach(async(mapMarker)=>{
        google.maps.event.addListener(mapMarker, "click", async function(event) {
          //console.log(this.position.lat(), this.position.lng());
          this.lat = this.position.lat();
          this.lng = this.position.lng();          
          document.querySelector('#lat').value = this.lat;
          document.querySelector('#lng').value = this.lng;
          let latLng = new google.maps.LatLng(this.position.lng(), this.position.lat());
          //console.log(latLng);
          let mapped = [];
          await fetch('https://maps.googleapis.com/maps/api/geocode/json?latlng='+this.lat+','+this.lng+'&key=AIzaSyDpyphfh5WL53gJJyH_0ww92CknU8XsKxU')
          .then(response=>response.json())
          .then(data=>{
            //console.log(data.plus_code.compound_code);
            mapped = data.plus_code.compound_code.split(' ');
            this.city = mapped[1];
            this.city = this.city.substr(0, this.city.lastIndexOf(','));
            this.country = mapped[2];
            document.querySelector('#city').value = this.city;
            document.querySelector('#country').value = this.country;
          });
        });
      });
    },
    getCurrentPosition: async function(){
      if('geolocation' in navigator){
        navigator.geolocation.getCurrentPosition(function(position){
          this.lat = position.coords.latitude;
          this.lng = position.coords.longitude;
          this.currentPosMarker = new google.maps.Marker({
            position:{
              lat: this.lat,
              lng: this.lng
            },
            title: 'You are here',
            map: this.map
          });
          console.log(this.currentPosMarker);
        });
      }
    }
  }
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
html,
body {
  margin: 0;
  padding: 0;
}

h3 {
  margin: 40px 0 0;
}
ul {
  list-style-type: none;
  padding: 0;
}
li {
  display: inline-block;
  margin: 0 10px;
}
a {
  color: #42b983;
}

.container {
  width: 100%;
  height: 100%;
  margin: auto;
  padding: 0;
}

#map {
  width: 100%;
  height: 980px;
  /* margin: 128px auto; */
}

.form{
  width: 40%;
  margin: auto;
  border: 1px solid;
}

.form .col{
  padding: 0;
}

.form-group label{
  width: auto;
  margin: auto;
  float: left;
}

.form-group input{
  width: 120px;
  height: auto;
  /* margin: 32px auto 32px auto; */
}
</style>
